From 7d2c497a1bef44bc377c34df3ce2bcae27e2e201 Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 7/48] Implement ModuleFilter


---

diff --git a/modulemd/__init__.py b/modulemd/__init__.py
index 69ccec7..b12d268 100644
--- a/modulemd/__init__.py
+++ b/modulemd/__init__.py
@@ -159,7 +159,6 @@ class ModuleMetadata(object):
         self.module.set_module_components({})
         self.module.set_rpm_artifacts(Modulemd.SimpleSet())
 
-        self.filter = ModuleFilter()
         self.buildopts = ModuleBuildopts()
         self.components = ModuleComponents()
         self.artifacts = ModuleArtifacts()
@@ -703,13 +702,19 @@ class ModuleMetadata(object):
     @property
     def filter(self):
         """A ModuleFilter instance representing the module's filter."""
-        return self._filter
+        filter = ModuleFilter(parent=self)
+        filter.rpms = set(self.module.get_rpm_filter().get())
+        return filter
 
     @filter.setter
     def filter(self, o):
         if not isinstance(o, ModuleFilter):
             raise TypeError("filter: data type not supported")
-        self._filter = o
+
+        rpms = Modulemd.SimpleSet()
+        rpms.set(list(o.rpms))
+
+        self.module.set_rpm_filter(rpms)
 
     @property
     def buildopts(self):
diff --git a/modulemd/filter.py b/modulemd/filter.py
index 232ad0d..b2cecd1 100644
--- a/modulemd/filter.py
+++ b/modulemd/filter.py
@@ -25,12 +25,15 @@
 
 supported_content = ( "rpms", )
 
+from gi.repository import Modulemd
+
 class ModuleFilter(object):
     """Class representing a particular module filter."""
 
-    def __init__(self):
+    def __init__(self, parent=None):
         """Creates a new ModuleFilter instance."""
         self.rpms = set()
+        self.parent = parent
 
     def __repr__(self):
         return ("<ModuleFilter: "
@@ -57,6 +60,11 @@ class ModuleFilter(object):
                 raise TypeError("filter.rpms: data type not supported")
         self._rpms = ss
 
+        if hasattr(self, 'parent'):
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            self.parent.module.set_rpm_filter(ss)
+
     def add_rpm(self, s):
         """Adds a binary RPM package to the filter set.
 
@@ -66,6 +74,11 @@ class ModuleFilter(object):
             raise TypeError("filter.add_rpm: data type not supported")
         self._rpms.add(s)
 
+        if hasattr(self, 'parent'):
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            self.parent.module.set_rpm_filter(ss)
+
     def del_rpm(self, s):
         """Removes the supplied package name from the filter package set.
 
@@ -75,6 +88,16 @@ class ModuleFilter(object):
             raise TypeError("filter.del_rpm: data type not supported")
         self._rpms.discard(s)
 
+        if hasattr(self, 'parent'):
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            self.parent.module.set_rpm_filter(ss)
+
     def clear_rpms(self):
         """Clear the filter binary RPM package set."""
         self._rpms.clear()
+
+        if hasattr(self, 'parent'):
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            self.parent.module.set_rpm_filter(ss)

